switch(forceRequiredAddOn(Weapon_Gun))
{
	case $Error::AddOn_Disabled: gunItem.uiName = "";
	case $Error::AddOn_NotFound: echo("\c2Weapon_Gun not found! Aborting..."); return;
}

datablock ParticleData(LGSRParticleA)
{
	dragCoefficient = 5;
	gravityCoefficient = 0;
	inheritedVelFactor = 1;
	constantAcceleration = 0;
	lifetimeMS = 100;
	lifetimeVarianceMS = 0;
	textureName = "base/data/particles/dot";
	spinSpeed = 0;
	spinRandomMin = 0;
	spinRandomMax = 0;
	useInvAlpha = false;
	colors[0] = "1 0 0 0.5";
	colors[1] = "1 0 0 0";
	sizes[0] = 0.1;
	sizes[1] = 0.1;
	times[0] = 0;
	times[1] = 1;
};
datablock ParticleEmitterData(LGSREmitterA)
{
	ejectionPeriodMS = 10;
	periodVarianceMS = 0;
	ejectionVelocity = 0;
	velocityVariance = 0;
	ejectionOffset = 0;
	thetaMin = 0;
	thetaMax = 180;
	phiReferenceVel = 0;
	phiVariance = 360;
	particles = "LGSRParticleA";
};

datablock ParticleData(LGSRParticleB)
{
	dragCoefficient = 0;
	gravityCoefficient = 0;
	inheritedVelFactor = 1;
	constantAcceleration = 0;
	lifetimeMS = 50;
	lifetimeVarianceMS = 5;
	textureName = "base/data/particles/dot";
	spinSpeed = 0;
	spinRandomMin = 0;
	spinRandomMax = 0;
	colors[0] = "1 0 0 0.3";
	colors[1] = "1 0 0 0.1";
	colors[2] = "1 0 0 0";
	sizes[0] = 0.05;
	sizes[1] = 0.05;
	sizes[2] = 0.05;
	times[0] = 0;
	times[1] = 0.5;
	times[2] = 1;
};
datablock ParticleEmitterData(LGSREmitterB)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 50;
	velocityVariance = 0;
	ejectionOffset = 0;
	thetaMin = 0;
	thetaMax = 0;
	phiReferenceVel = 0;
	phiVariance = 360;
	particles = "LGSRParticleB";
};

%bitmap = "<bitmap:Add-Ons/Weapon_Sniper/CI_Sniper>";
addDamageType('LGSR', %bitmap @ ' %1', '%2 ' @ %bitmap @ ' %1', 0.2, 1);

datablock ProjectileData(LGSRProjectile)
{
	projectileShapeName = "base/data/shapes/empty.dts";
	particleEmitter = LGSREmitterA;
	muzzleVelocity = 1;
	velInheritFactor = 1;
	armingDelay = 100;
	lifetime = 100;
	fadeDelay = 100;
	bounceElasticity = 0;
	bounceFriction = 0;
	isBallistic = true;
	gravityMod = 0;
	hasLight = false;
	lightRadius = 1;
	lightColor = "1 0 0";
};

datablock ItemData(LGSRItem)
{
	category = "Weapon";
	className = "Weapon";
	shapeFile = "./Sniper.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	uiName = "Laser-Guided S. Rifle";
	iconName = "Add-Ons/Weapon_Sniper/Icon_Sniper";
	doColorShift = true;
	colorShiftColor = "0.1 0.1 0.2 1";
	image = LGSRImage;
	canDrop = true;
};

datablock ShapeBaseImageData(LGSRImage)
{
	shapeFile = LGSRItem.shapeFile;
	emap = true;
	doColorShift = true;
	colorShiftColor = LGSRItem.colorShiftColor;
	correctMuzzleVector = true;
	melee = false;
	projectile = "";
	projectileType = "";
	ammo = " ";
	casing = gunShellDebris;
	shellExitDir = "1 -1.3 1";
	shellExitOffset = "0 0 0";
	shellExitVariance = 15;	
	shellVelocity = 7;
	armReady = true;
	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0;
	rotation = "0 0 0";
	minShotTime = 1500;
	className = "WeaponImage";
	item = LGSRItem;

	stateName[0]                   = "Activate";
	stateTimeoutValue[0]           = 0.15;
	stateTransitionOnTimeout[0]    = "Ready";
	stateSound[0]                  = weaponSwitchSound;

	stateName[1]                   = "Ready";
	stateTransitionOnTriggerDown[1]= "Fire";
	stateSequence[1]               = "Ready";
	stateEmitter[1]                = LGSREmitterB;
	stateEmitterTime[1]            = 0.05;
	stateEmitterNode[1]            = "muzzleNode";
	stateScript[1]                 = "Search";
	stateTimeoutValue[1]           = 0.01;
	stateTransitionOnTimeout[1]    = "Ready";

	stateName[2]                   = "Fire";
	stateTransitionOnTimeout[2]    = "Smoke";
	stateTimeoutValue[2]           = 0.1;
	stateFire[2]                   = true;
	stateAllowImageChange[2]       = false;
	stateSequence[2]               = "Fire";
	stateScript[2]                 = "onFire";
	stateWaitForTimeout[2]         = true;
	stateEmitter[2]                = gunFlashEmitter;
	stateEmitterTime[2]            = 0.1;
	stateEmitterNode[2]            = "muzzleNode";
	stateSound[2]                  = gunShot1Sound;
	stateEjectShell[2]             = true;

	stateName[3]                   = "Smoke";
	stateEmitter[3]                = gunSmokeEmitter;
	stateEmitterTime[3]            = 1.5;
	stateEmitterNode[3]            = "muzzleNode";
	stateTimeoutValue[3]           = 1.5;
	stateTransitionOnTimeout[3]    = "Reload";

	stateName[4]                   = "Reload";
	stateSequence[4]               = "Reload";
	stateTransitionOnTriggerUp[4]  = "Ready";
	stateSequence[4]               = "Ready";
};

function LGSRImage::Search(%this, %obj, %slot)
{
	%start = %obj.getMuzzlePoint(%slot);
	%end = vectorAdd(%start, vectorScale(%obj.getMuzzleVector(%slot), 500));
	%typemasks = $Typemasks::PlayerObjectType | $Typemasks::FxBrickObjectType | $Typemasks::TerrainObjectType | $Typemasks::InteriorObjectType | $TypeMasks::StaticObjectType | $TypeMasks::VehicleObjectType;
	%ray = containerRaycast(%start, %end, %typemasks, %obj);
	if(isObject(%hit = firstWord(%ray)))
	{
		%pos = posFromRaycast(%ray);
		%apos = vectorAdd(%pos, vectorScale(normalFromRaycast(%ray), 0.05));
		%prj = new Projectile()
		{
			datablock = LGSRProjectile;
			initialPosition = %apos;
			initialVelocity = "0 0 0";
			scale = %obj.getScale();
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
	}
}

function LGSRImage::onFire(%this, %obj, %slot)
{
	if(%obj.lastShot[%this] + %this.minShotTime > getSimTime())
	{
		return;
	}
	%obj.lastShot[%this] = getSimTime();
	%start = %obj.getMuzzlePoint(%slot);
	%end = vectorAdd(%start, vectorScale(%obj.getMuzzleVector(%slot), 500));
	%typemasks = $Typemasks::PlayerObjectType | $Typemasks::FxBrickObjectType | $Typemasks::TerrainObjectType | $Typemasks::InteriorObjectType | $TypeMasks::StaticObjectType | $TypeMasks::VehicleObjectType;
	%ray = containerRaycast(%start, %end, %typemasks, %obj);
	if(isObject(%hit = firstWord(%ray)))
	{
		%pos = posFromRaycast(%ray);
		%apos = vectorAdd(%pos, vectorScale(normalFromRaycast(%ray), 0.05));
		%prj = new Projectile()
		{
			datablock = gunProjectile;
			initialPosition = %apos;
			initialVelocity = vectorScale(%obj.getMuzzleVector(%slot), 200);
			scale = %obj.getScale();
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
			LGSRbullet = true;
		};
	}
}

package LGSR
{
	function gunProjectile::damage(%this, %obj, %col, %fade, %pos, %normal)
	{
		if(!%obj.LGSRbullet)
		{
			return parent::damage(%this, %obj, %col, %fade, %pos, %normal);
		}
		else
		{
			%col.damage(%obj, %pos, getWord(%obj.getscale(), 2) * 100, $DamageType::LGSR);
		}
	}
};
activatePackage(LGSR);